---
---
<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>TGUI: include/TGUI/Widgets/ChatBox.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<!-- BEGIN CUSTOM 1 -->
<!-- --{{""}}>
{% include head.ext %}
<style>
  div {
    margin-bottom: 0
  }
  #contents {
    padding-left: 0;
    padding-right: 0;
    margin-left: 0;
    margin-right: 0;
    max-width: 1060px;
  }
  address.footer {
    padding-bottom: 1.4em;
  }
</style>
<script type="text/javascript">
function getXPos(item) {
  var x = 0;
  if (item.offsetWidth) {
    while (item && item != document.body && item.id != 'body') {
      x   += item.offsetLeft;
      item = item.offsetParent;
    }
  }
  return x;
}
</script>
<{{""}}!-- -->
<!-- END CUSTOM 1 -->
</head>
<body>
<!-- BEGIN CUSTOM 2 -->
<!-- --{{""}}>
<div id="body" class="NoMargin">
{% include navigation.ext %}
<div id="contents" class="NoMargin">
<{{""}}!-- {% raw %} -->
<!-- END CUSTOM 2 -->
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">TGUI
   &#160;<span id="projectnumber">v0.7-dev</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_380f920385a16f176be7632160138052.html">TGUI</a></li><li class="navelem"><a class="el" href="dir_0bb95f096d007de7ff009a2d5974766c.html">Widgets</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ChatBox.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// TGUI - Texus&#39;s Graphical User Interface</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// Copyright (C) 2012-2017 Bruno Van de Velde (vdv_b@tgui.eu)</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">// This software is provided &#39;as-is&#39;, without any express or implied warranty.</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">// In no event will the authors be held liable for any damages arising from the use of this software.</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// Permission is granted to anyone to use this software for any purpose,</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// including commercial applications, and to alter it and redistribute it freely,</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// subject to the following restrictions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// 1. The origin of this software must not be misrepresented;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//    you must not claim that you wrote the original software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//    If you use this software in a product, an acknowledgment</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//    in the product documentation would be appreciated but is not required.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// 2. Altered source versions must be plainly marked as such,</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//    and must not be misrepresented as being the original software.</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// 3. This notice may not be removed or altered from any source distribution.</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifndef TGUI_CHAT_BOX_HPP</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#define TGUI_CHAT_BOX_HPP</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;TGUI/Widget.hpp&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;TGUI/Widgets/Panel.hpp&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;TGUI/Widgets/Scrollbar.hpp&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;deque&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacetgui.html">tgui</a></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;{</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keyword">class </span>Scrollbar;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">class </span>ChatBoxRenderer;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="classtgui_1_1ChatBox.html">   45</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1ChatBox.html">ChatBox</a> : <span class="keyword">public</span> <a class="code" href="classtgui_1_1Widget.html">Widget</a></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    {</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classtgui_1_1ChatBox.html#aaa36242b970d5f511390009192acf76a">   49</a></span>&#160;        <span class="keyword">typedef</span> std::shared_ptr&lt;ChatBox&gt; <a class="code" href="classtgui_1_1ChatBox.html#aaa36242b970d5f511390009192acf76a">Ptr</a>; </div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classtgui_1_1ChatBox.html#a537c029e81189e1e8624cded0cf9d0cd">   50</a></span>&#160;        <span class="keyword">typedef</span> std::shared_ptr&lt;const ChatBox&gt; <a class="code" href="classtgui_1_1ChatBox.html#a537c029e81189e1e8624cded0cf9d0cd">ConstPtr</a>; </div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="structtgui_1_1ChatBox_1_1Line.html">   56</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="structtgui_1_1ChatBox_1_1Line.html">Line</a></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        {</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            sf::Text text;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            sf::String string;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sublines = 1;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            std::shared_ptr&lt;sf::Font&gt; font;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        };</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="comment">// Default constructor</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment"></span>        <a class="code" href="classtgui_1_1ChatBox.html">ChatBox</a>();</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <a class="code" href="classtgui_1_1ChatBox.html">ChatBox</a>(<span class="keyword">const</span> <a class="code" href="classtgui_1_1ChatBox.html">ChatBox</a>&amp; copy);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <a class="code" href="classtgui_1_1ChatBox.html">ChatBox</a>&amp; operator= (<span class="keyword">const</span> <a class="code" href="classtgui_1_1ChatBox.html">ChatBox</a>&amp; right);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <span class="keyword">static</span> <a class="code" href="classtgui_1_1ChatBox.html#aaa36242b970d5f511390009192acf76a">ChatBox::Ptr</a> create();</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keyword">static</span> <a class="code" href="classtgui_1_1ChatBox.html#aaa36242b970d5f511390009192acf76a">ChatBox::Ptr</a> copy(<a class="code" href="classtgui_1_1ChatBox.html#a537c029e81189e1e8624cded0cf9d0cd">ChatBox::ConstPtr</a> chatBox);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno"><a class="line" href="classtgui_1_1ChatBox.html#a1a3f0485d619252f74c4846b496c00f4">  120</a></span>&#160;        std::shared_ptr&lt;ChatBoxRenderer&gt; <a class="code" href="classtgui_1_1ChatBox.html#a1a3f0485d619252f74c4846b496c00f4">getRenderer</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;            <span class="keywordflow">return</span> std::static_pointer_cast&lt;<a class="code" href="classtgui_1_1ChatBoxRenderer.html">ChatBoxRenderer</a>&gt;(m_renderer);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        }</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="keywordtype">void</span> setSize(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a>&amp; size) <span class="keyword">override</span>;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keyword">using</span> <a class="code" href="classtgui_1_1Transformable.html#a66fe5d2a7b1477cab073984a9a3e13bc">Transformable::setSize</a>;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="keyword">virtual</span> sf::Vector2f getFullSize() <span class="keyword">const override</span>;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keywordtype">void</span> addLine(<span class="keyword">const</span> sf::String&amp; text);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keywordtype">void</span> addLine(<span class="keyword">const</span> sf::String&amp; text, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> textSize);</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keywordtype">void</span> addLine(<span class="keyword">const</span> sf::String&amp; text, <span class="keyword">const</span> sf::Color&amp; color);</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <span class="keywordtype">void</span> addLine(<span class="keyword">const</span> sf::String&amp; text, <span class="keyword">const</span> sf::Color&amp; color, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> textSize, <span class="keyword">const</span> <a class="code" href="classtgui_1_1Font.html">Font</a>&amp; font = <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        sf::String getLine(std::size_t lineIndex) <span class="keyword">const</span>;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        sf::Color getLineColor(std::size_t lineIndex) <span class="keyword">const</span>;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getLineTextSize(std::size_t lineIndex) <span class="keyword">const</span>;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        std::shared_ptr&lt;sf::Font&gt; getLineFont(std::size_t lineIndex) <span class="keyword">const</span>;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        <span class="keywordtype">bool</span> removeLine(std::size_t lineIndex);</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        <span class="keywordtype">void</span> removeAllLines();</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        std::size_t getLineAmount();</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="keywordtype">void</span> setLineLimit(std::size_t maxLines);</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;        std::size_t getLineLimit();</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFont(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Font.html">Font</a>&amp; font) <span class="keyword">override</span>;</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;        <span class="keywordtype">void</span> setTextSize(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size);</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;</div><div class="line"><a name="l00333"></a><span class="lineno"><a class="line" href="classtgui_1_1ChatBox.html#a16b9fb1438cea91963bce26c1fe49ff3">  333</a></span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classtgui_1_1ChatBox.html#a16b9fb1438cea91963bce26c1fe49ff3">getTextSize</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;            <span class="keywordflow">return</span> m_textSize;</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;        }</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;        <span class="keywordtype">void</span> setTextColor(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Color.html">Color</a>&amp; color);</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;</div><div class="line"><a name="l00354"></a><span class="lineno"><a class="line" href="classtgui_1_1ChatBox.html#a00cb473b252f9cfe522f70f9b0146b6e">  354</a></span>&#160;        <span class="keyword">const</span> sf::Color&amp; <a class="code" href="classtgui_1_1ChatBox.html#a00cb473b252f9cfe522f70f9b0146b6e">getTextColor</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;            <span class="keywordflow">return</span> m_textColor;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;        }</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;        <span class="keywordtype">void</span> setScrollbar(<a class="code" href="classtgui_1_1Scrollbar.html#abb6fe6c3e98166c60f43ef95536effb3">Scrollbar::Ptr</a> scrollbar);</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;        <a class="code" href="classtgui_1_1Scrollbar.html#abb6fe6c3e98166c60f43ef95536effb3">Scrollbar::Ptr</a> getScrollbar() <span class="keyword">const</span>;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;        <span class="keywordtype">void</span> setLinesStartFromTop(<span class="keywordtype">bool</span> startFromTop = <span class="keyword">true</span>);</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        <span class="keywordtype">bool</span> getLinesStartFromTop() <span class="keyword">const</span>;</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;        <span class="keywordtype">void</span> setNewLinesBelowOthers(<span class="keywordtype">bool</span> newLinesBelowOthers = <span class="keyword">true</span>);</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;</div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;        <span class="keywordtype">bool</span> getNewLinesBelowOthers() <span class="keyword">const</span>;</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;</div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOpacity(<span class="keywordtype">float</span> opacity) <span class="keyword">override</span>;</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;        <span class="keyword">virtual</span> sf::Vector2f getWidgetOffset() <span class="keyword">const override</span>;</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;</div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setParent(<a class="code" href="classtgui_1_1Container.html">Container</a>* parent) <span class="keyword">override</span>;</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">bool</span> mouseOnWidget(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y) <span class="keyword">const override</span>;</div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> leftMousePressed(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y) <span class="keyword">override</span>;</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> leftMouseReleased(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y) <span class="keyword">override</span>;</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> mouseMoved(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y) <span class="keyword">override</span>;</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;</div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> mouseWheelMoved(<span class="keywordtype">int</span> delta, <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y) <span class="keyword">override</span>;</div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;</div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> mouseNoLongerOnWidget() <span class="keyword">override</span>;</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;</div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> mouseNoLongerDown() <span class="keyword">override</span>;</div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;</div><div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;</div><div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;        <span class="comment">// Recalculates the text attribute of the line</span></div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> recalculateLineText(<a class="code" href="structtgui_1_1ChatBox_1_1Line.html">Line</a>&amp; line);</div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;        <span class="comment">// Recalculates all text attributes, recalculate the full text height and update the displayed text</span></div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> recalculateAllLines();</div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;</div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;</div><div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;        <span class="comment">// Recalculates the space used by all the lines</span></div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> recalculateFullTextHeight();</div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;</div><div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;</div><div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160;        <span class="comment">// Updates the position of the lines</span></div><div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> updateDisplayedText();</div><div class="line"><a name="l00524"></a><span class="lineno">  524</span>&#160;</div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;</div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;        <span class="comment">// Updates the position and size of the panel and scrollbar</span></div><div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> updateRendering();</div><div class="line"><a name="l00530"></a><span class="lineno">  530</span>&#160;</div><div class="line"><a name="l00531"></a><span class="lineno">  531</span>&#160;</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160;</div><div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> reload(<span class="keyword">const</span> std::string&amp; primary = <span class="stringliteral">&quot;&quot;</span>, <span class="keyword">const</span> std::string&amp; secondary = <span class="stringliteral">&quot;&quot;</span>, <span class="keywordtype">bool</span> force = <span class="keyword">false</span>) <span class="keyword">override</span>;</div><div class="line"><a name="l00548"></a><span class="lineno">  548</span>&#160;</div><div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;</div><div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160;        <span class="comment">// Makes a copy of the widget</span></div><div class="line"><a name="l00553"></a><span class="lineno"><a class="line" href="classtgui_1_1ChatBox.html#ad3877d752057a692b1eee62b6c809b73">  553</a></span>&#160;<span class="comment"></span>        <span class="keyword">virtual</span> <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a> <a class="code" href="classtgui_1_1ChatBox.html#ad3877d752057a692b1eee62b6c809b73">clone</a>()<span class="keyword"> const override</span></div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160;            <span class="keywordflow">return</span> std::make_shared&lt;ChatBox&gt;(*this);</div><div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;        }</div><div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160;</div><div class="line"><a name="l00558"></a><span class="lineno">  558</span>&#160;</div><div class="line"><a name="l00560"></a><span class="lineno">  560</span>&#160;        <span class="comment">// Draws the widget on the render target.</span></div><div class="line"><a name="l00562"></a><span class="lineno">  562</span>&#160;<span class="comment"></span>        <span class="keyword">virtual</span> <span class="keywordtype">void</span> draw(sf::RenderTarget&amp; target, sf::RenderStates states) <span class="keyword">const override</span>;</div><div class="line"><a name="l00563"></a><span class="lineno">  563</span>&#160;</div><div class="line"><a name="l00564"></a><span class="lineno">  564</span>&#160;</div><div class="line"><a name="l00566"></a><span class="lineno">  566</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;</div><div class="line"><a name="l00568"></a><span class="lineno">  568</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_textSize = 18;</div><div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;        sf::Color m_textColor = sf::Color::Black;</div><div class="line"><a name="l00570"></a><span class="lineno">  570</span>&#160;</div><div class="line"><a name="l00571"></a><span class="lineno">  571</span>&#160;        std::size_t m_maxLines = 0;</div><div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160;</div><div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;        <span class="keywordtype">float</span> m_fullTextHeight = 0;</div><div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;</div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;        <span class="keywordtype">bool</span> m_linesStartFromTop = <span class="keyword">false</span>;</div><div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;        <span class="keywordtype">bool</span> m_newLinesBelowOthers = <span class="keyword">true</span>;</div><div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;</div><div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160;        <a class="code" href="classtgui_1_1Scrollbar.html#abb6fe6c3e98166c60f43ef95536effb3">Scrollbar::Ptr</a> m_scroll = std::make_shared&lt;Scrollbar&gt;();</div><div class="line"><a name="l00579"></a><span class="lineno">  579</span>&#160;</div><div class="line"><a name="l00580"></a><span class="lineno">  580</span>&#160;        std::deque&lt;Line&gt; m_lines;</div><div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;</div><div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classtgui_1_1ChatBoxRenderer.html">ChatBoxRenderer</a>;</div><div class="line"><a name="l00583"></a><span class="lineno">  583</span>&#160;</div><div class="line"><a name="l00585"></a><span class="lineno">  585</span>&#160;    };</div><div class="line"><a name="l00586"></a><span class="lineno">  586</span>&#160;</div><div class="line"><a name="l00587"></a><span class="lineno">  587</span>&#160;</div><div class="line"><a name="l00589"></a><span class="lineno">  589</span>&#160;</div><div class="line"><a name="l00590"></a><span class="lineno"><a class="line" href="classtgui_1_1ChatBoxRenderer.html">  590</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1ChatBoxRenderer.html">ChatBoxRenderer</a> : <span class="keyword">public</span> <a class="code" href="classtgui_1_1WidgetRenderer.html">WidgetRenderer</a>, <span class="keyword">public</span> <a class="code" href="classtgui_1_1WidgetBorders.html">WidgetBorders</a>, <span class="keyword">public</span> <a class="code" href="classtgui_1_1WidgetPadding.html">WidgetPadding</a></div><div class="line"><a name="l00591"></a><span class="lineno">  591</span>&#160;    {</div><div class="line"><a name="l00592"></a><span class="lineno">  592</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00593"></a><span class="lineno">  593</span>&#160;</div><div class="line"><a name="l00600"></a><span class="lineno"><a class="line" href="classtgui_1_1ChatBoxRenderer.html#a14e932d95a242784db7633e573e79ee3">  600</a></span>&#160;        <a class="code" href="classtgui_1_1ChatBoxRenderer.html#a14e932d95a242784db7633e573e79ee3">ChatBoxRenderer</a>(<a class="code" href="classtgui_1_1ChatBox.html">ChatBox</a>* chatBox) : m_chatBox{chatBox} {}</div><div class="line"><a name="l00601"></a><span class="lineno">  601</span>&#160;</div><div class="line"><a name="l00602"></a><span class="lineno">  602</span>&#160;</div><div class="line"><a name="l00613"></a><span class="lineno">  613</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setProperty(std::string property, <span class="keyword">const</span> std::string&amp; value) <span class="keyword">override</span>;</div><div class="line"><a name="l00614"></a><span class="lineno">  614</span>&#160;</div><div class="line"><a name="l00615"></a><span class="lineno">  615</span>&#160;</div><div class="line"><a name="l00627"></a><span class="lineno">  627</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setProperty(std::string property, <a class="code" href="classtgui_1_1ObjectConverter.html">ObjectConverter</a>&amp;&amp; value) <span class="keyword">override</span>;</div><div class="line"><a name="l00628"></a><span class="lineno">  628</span>&#160;</div><div class="line"><a name="l00629"></a><span class="lineno">  629</span>&#160;</div><div class="line"><a name="l00639"></a><span class="lineno">  639</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="classtgui_1_1ObjectConverter.html">ObjectConverter</a> getProperty(std::string property) <span class="keyword">const override</span>;</div><div class="line"><a name="l00640"></a><span class="lineno">  640</span>&#160;</div><div class="line"><a name="l00641"></a><span class="lineno">  641</span>&#160;</div><div class="line"><a name="l00648"></a><span class="lineno">  648</span>&#160;        <span class="keyword">virtual</span> std::map&lt;std::string, ObjectConverter&gt; getPropertyValuePairs() <span class="keyword">const override</span>;</div><div class="line"><a name="l00649"></a><span class="lineno">  649</span>&#160;</div><div class="line"><a name="l00650"></a><span class="lineno">  650</span>&#160;</div><div class="line"><a name="l00657"></a><span class="lineno">  657</span>&#160;        <span class="keywordtype">void</span> setBorderColor(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Color.html">Color</a>&amp; borderColor);</div><div class="line"><a name="l00658"></a><span class="lineno">  658</span>&#160;</div><div class="line"><a name="l00659"></a><span class="lineno">  659</span>&#160;</div><div class="line"><a name="l00668"></a><span class="lineno">  668</span>&#160;        <span class="keywordtype">void</span> setBackgroundColor(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Color.html">Color</a>&amp; backgroundColor);</div><div class="line"><a name="l00669"></a><span class="lineno">  669</span>&#160;</div><div class="line"><a name="l00670"></a><span class="lineno">  670</span>&#160;</div><div class="line"><a name="l00680"></a><span class="lineno">  680</span>&#160;        <span class="keywordtype">void</span> setBackgroundTexture(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Texture.html">Texture</a>&amp; texture);</div><div class="line"><a name="l00681"></a><span class="lineno">  681</span>&#160;</div><div class="line"><a name="l00682"></a><span class="lineno">  682</span>&#160;</div><div class="line"><a name="l00692"></a><span class="lineno">  692</span>&#160;        <span class="keywordtype">void</span> setPadding(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Borders.html">Padding</a>&amp; padding) <span class="keyword">override</span>;</div><div class="line"><a name="l00693"></a><span class="lineno">  693</span>&#160;        <span class="keyword">using</span> <a class="code" href="classtgui_1_1WidgetPadding.html#a06448dfb10275ea7939c248ddf88f46d">WidgetPadding::setPadding</a>;</div><div class="line"><a name="l00694"></a><span class="lineno">  694</span>&#160;</div><div class="line"><a name="l00695"></a><span class="lineno">  695</span>&#160;</div><div class="line"><a name="l00697"></a><span class="lineno">  697</span>&#160;        <span class="comment">// Draws the widget on the render target.</span></div><div class="line"><a name="l00699"></a><span class="lineno">  699</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> draw(sf::RenderTarget&amp; target, sf::RenderStates states) <span class="keyword">const</span>;</div><div class="line"><a name="l00700"></a><span class="lineno">  700</span>&#160;</div><div class="line"><a name="l00701"></a><span class="lineno">  701</span>&#160;</div><div class="line"><a name="l00703"></a><span class="lineno">  703</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00704"></a><span class="lineno">  704</span>&#160;</div><div class="line"><a name="l00706"></a><span class="lineno">  706</span>&#160;        <span class="comment">// Returns the padding, which is possibly scaled with the background image.</span></div><div class="line"><a name="l00708"></a><span class="lineno">  708</span>&#160;<span class="comment"></span>        <a class="code" href="classtgui_1_1Borders.html">Padding</a> getScaledPadding() <span class="keyword">const</span>;</div><div class="line"><a name="l00709"></a><span class="lineno">  709</span>&#160;</div><div class="line"><a name="l00710"></a><span class="lineno">  710</span>&#160;</div><div class="line"><a name="l00712"></a><span class="lineno">  712</span>&#160;        <span class="comment">// Makes a copy of the renderer</span></div><div class="line"><a name="l00714"></a><span class="lineno">  714</span>&#160;<span class="comment"></span>        <span class="keyword">virtual</span> std::shared_ptr&lt;WidgetRenderer&gt; clone(<a class="code" href="classtgui_1_1Widget.html">Widget</a>* widget) <span class="keyword">override</span>;</div><div class="line"><a name="l00715"></a><span class="lineno">  715</span>&#160;</div><div class="line"><a name="l00716"></a><span class="lineno">  716</span>&#160;</div><div class="line"><a name="l00718"></a><span class="lineno">  718</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00719"></a><span class="lineno">  719</span>&#160;</div><div class="line"><a name="l00720"></a><span class="lineno">  720</span>&#160;        <a class="code" href="classtgui_1_1ChatBox.html">ChatBox</a>* m_chatBox;</div><div class="line"><a name="l00721"></a><span class="lineno">  721</span>&#160;</div><div class="line"><a name="l00722"></a><span class="lineno">  722</span>&#160;        sf::Color m_borderColor;</div><div class="line"><a name="l00723"></a><span class="lineno">  723</span>&#160;        sf::Color m_backgroundColor;</div><div class="line"><a name="l00724"></a><span class="lineno">  724</span>&#160;</div><div class="line"><a name="l00725"></a><span class="lineno">  725</span>&#160;        <a class="code" href="classtgui_1_1Texture.html">Texture</a> m_backgroundTexture;</div><div class="line"><a name="l00726"></a><span class="lineno">  726</span>&#160;</div><div class="line"><a name="l00727"></a><span class="lineno">  727</span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classtgui_1_1ChatBox.html">ChatBox</a>;</div><div class="line"><a name="l00728"></a><span class="lineno">  728</span>&#160;    };</div><div class="line"><a name="l00729"></a><span class="lineno">  729</span>&#160;</div><div class="line"><a name="l00731"></a><span class="lineno">  731</span>&#160;}</div><div class="line"><a name="l00732"></a><span class="lineno">  732</span>&#160;</div><div class="line"><a name="l00734"></a><span class="lineno">  734</span>&#160;</div><div class="line"><a name="l00735"></a><span class="lineno">  735</span>&#160;<span class="preprocessor">#endif // TGUI_TEXT_BOX_HPP</span></div><div class="ttc" id="namespacetgui_html"><div class="ttname"><a href="namespacetgui.html">tgui</a></div><div class="ttdoc">Namespace that contains all TGUI functions and classes. </div><div class="ttdef"><b>Definition:</b> Animation.hpp:33</div></div>
<div class="ttc" id="classtgui_1_1WidgetPadding_html_a06448dfb10275ea7939c248ddf88f46d"><div class="ttname"><a href="classtgui_1_1WidgetPadding.html#a06448dfb10275ea7939c248ddf88f46d">tgui::WidgetPadding::setPadding</a></div><div class="ttdeci">virtual void setPadding(const Padding &amp;padding)</div><div class="ttdoc">Changes the size of the padding. </div><div class="ttdef"><b>Definition:</b> Borders.hpp:223</div></div>
<div class="ttc" id="classtgui_1_1Color_html"><div class="ttname"><a href="classtgui_1_1Color.html">tgui::Color</a></div><div class="ttdoc">Implicit converter for colors. </div><div class="ttdef"><b>Definition:</b> Color.hpp:39</div></div>
<div class="ttc" id="classtgui_1_1ChatBox_html_a00cb473b252f9cfe522f70f9b0146b6e"><div class="ttname"><a href="classtgui_1_1ChatBox.html#a00cb473b252f9cfe522f70f9b0146b6e">tgui::ChatBox::getTextColor</a></div><div class="ttdeci">const sf::Color &amp; getTextColor() const </div><div class="ttdoc">Returns the default color of the text. </div><div class="ttdef"><b>Definition:</b> ChatBox.hpp:354</div></div>
<div class="ttc" id="classtgui_1_1Font_html"><div class="ttname"><a href="classtgui_1_1Font.html">tgui::Font</a></div><div class="ttdef"><b>Definition:</b> Font.hpp:37</div></div>
<div class="ttc" id="classtgui_1_1Layout2d_html"><div class="ttname"><a href="classtgui_1_1Layout2d.html">tgui::Layout2d</a></div><div class="ttdoc">Class to store the position or size of a widget. </div><div class="ttdef"><b>Definition:</b> Layout.hpp:254</div></div>
<div class="ttc" id="classtgui_1_1Widget_html"><div class="ttname"><a href="classtgui_1_1Widget.html">tgui::Widget</a></div><div class="ttdoc">The parent class for every widget. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:71</div></div>
<div class="ttc" id="classtgui_1_1ChatBox_html_a537c029e81189e1e8624cded0cf9d0cd"><div class="ttname"><a href="classtgui_1_1ChatBox.html#a537c029e81189e1e8624cded0cf9d0cd">tgui::ChatBox::ConstPtr</a></div><div class="ttdeci">std::shared_ptr&lt; const ChatBox &gt; ConstPtr</div><div class="ttdoc">Shared constant widget pointer. </div><div class="ttdef"><b>Definition:</b> ChatBox.hpp:50</div></div>
<div class="ttc" id="classtgui_1_1ChatBoxRenderer_html_a14e932d95a242784db7633e573e79ee3"><div class="ttname"><a href="classtgui_1_1ChatBoxRenderer.html#a14e932d95a242784db7633e573e79ee3">tgui::ChatBoxRenderer::ChatBoxRenderer</a></div><div class="ttdeci">ChatBoxRenderer(ChatBox *chatBox)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> ChatBox.hpp:600</div></div>
<div class="ttc" id="classtgui_1_1Scrollbar_html_abb6fe6c3e98166c60f43ef95536effb3"><div class="ttname"><a href="classtgui_1_1Scrollbar.html#abb6fe6c3e98166c60f43ef95536effb3">tgui::Scrollbar::Ptr</a></div><div class="ttdeci">std::shared_ptr&lt; Scrollbar &gt; Ptr</div><div class="ttdoc">Shared widget pointer. </div><div class="ttdef"><b>Definition:</b> Scrollbar.hpp:53</div></div>
<div class="ttc" id="classtgui_1_1ChatBox_html_aaa36242b970d5f511390009192acf76a"><div class="ttname"><a href="classtgui_1_1ChatBox.html#aaa36242b970d5f511390009192acf76a">tgui::ChatBox::Ptr</a></div><div class="ttdeci">std::shared_ptr&lt; ChatBox &gt; Ptr</div><div class="ttdoc">Shared widget pointer. </div><div class="ttdef"><b>Definition:</b> ChatBox.hpp:49</div></div>
<div class="ttc" id="structtgui_1_1ChatBox_1_1Line_html"><div class="ttname"><a href="structtgui_1_1ChatBox_1_1Line.html">tgui::ChatBox::Line</a></div><div class="ttdef"><b>Definition:</b> ChatBox.hpp:56</div></div>
<div class="ttc" id="classtgui_1_1ChatBox_html_ad3877d752057a692b1eee62b6c809b73"><div class="ttname"><a href="classtgui_1_1ChatBox.html#ad3877d752057a692b1eee62b6c809b73">tgui::ChatBox::clone</a></div><div class="ttdeci">virtual Widget::Ptr clone() const  override</div><div class="ttdoc">Makes a copy of the widget if you don&amp;#39;t know its exact type. </div><div class="ttdef"><b>Definition:</b> ChatBox.hpp:553</div></div>
<div class="ttc" id="classtgui_1_1Transformable_html_a66fe5d2a7b1477cab073984a9a3e13bc"><div class="ttname"><a href="classtgui_1_1Transformable.html#a66fe5d2a7b1477cab073984a9a3e13bc">tgui::Transformable::setSize</a></div><div class="ttdeci">virtual void setSize(const Layout2d &amp;size)</div><div class="ttdoc">Changes the size of the widget. </div></div>
<div class="ttc" id="classtgui_1_1WidgetPadding_html"><div class="ttname"><a href="classtgui_1_1WidgetPadding.html">tgui::WidgetPadding</a></div><div class="ttdoc">Parent class for every widget that has padding. </div><div class="ttdef"><b>Definition:</b> Borders.hpp:210</div></div>
<div class="ttc" id="classtgui_1_1WidgetBorders_html"><div class="ttname"><a href="classtgui_1_1WidgetBorders.html">tgui::WidgetBorders</a></div><div class="ttdoc">Parent class for every widget that has borders. </div><div class="ttdef"><b>Definition:</b> Borders.hpp:136</div></div>
<div class="ttc" id="classtgui_1_1ObjectConverter_html"><div class="ttname"><a href="classtgui_1_1ObjectConverter.html">tgui::ObjectConverter</a></div><div class="ttdoc">Implicit converter for settable properties. </div><div class="ttdef"><b>Definition:</b> ObjectConverter.hpp:42</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_a388912f13898735531886bc676b14f81"><div class="ttname"><a href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">tgui::Widget::Ptr</a></div><div class="ttdeci">std::shared_ptr&lt; Widget &gt; Ptr</div><div class="ttdoc">Shared widget pointer. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:75</div></div>
<div class="ttc" id="classtgui_1_1Container_html"><div class="ttname"><a href="classtgui_1_1Container.html">tgui::Container</a></div><div class="ttdoc">Container widget. </div><div class="ttdef"><b>Definition:</b> Container.hpp:47</div></div>
<div class="ttc" id="classtgui_1_1ChatBoxRenderer_html"><div class="ttname"><a href="classtgui_1_1ChatBoxRenderer.html">tgui::ChatBoxRenderer</a></div><div class="ttdef"><b>Definition:</b> ChatBox.hpp:590</div></div>
<div class="ttc" id="classtgui_1_1Texture_html"><div class="ttname"><a href="classtgui_1_1Texture.html">tgui::Texture</a></div><div class="ttdef"><b>Definition:</b> Texture.hpp:44</div></div>
<div class="ttc" id="classtgui_1_1Borders_html"><div class="ttname"><a href="classtgui_1_1Borders.html">tgui::Borders</a></div><div class="ttdef"><b>Definition:</b> Borders.hpp:37</div></div>
<div class="ttc" id="classtgui_1_1ChatBox_html_a16b9fb1438cea91963bce26c1fe49ff3"><div class="ttname"><a href="classtgui_1_1ChatBox.html#a16b9fb1438cea91963bce26c1fe49ff3">tgui::ChatBox::getTextSize</a></div><div class="ttdeci">unsigned int getTextSize() const </div><div class="ttdoc">Returns the default character size of the text. </div><div class="ttdef"><b>Definition:</b> ChatBox.hpp:333</div></div>
<div class="ttc" id="classtgui_1_1ChatBox_html_a1a3f0485d619252f74c4846b496c00f4"><div class="ttname"><a href="classtgui_1_1ChatBox.html#a1a3f0485d619252f74c4846b496c00f4">tgui::ChatBox::getRenderer</a></div><div class="ttdeci">std::shared_ptr&lt; ChatBoxRenderer &gt; getRenderer() const </div><div class="ttdoc">Returns the renderer, which gives access to functions that determine how the widget is displayed...</div><div class="ttdef"><b>Definition:</b> ChatBox.hpp:120</div></div>
<div class="ttc" id="classtgui_1_1WidgetRenderer_html"><div class="ttname"><a href="classtgui_1_1WidgetRenderer.html">tgui::WidgetRenderer</a></div><div class="ttdoc">Base class for all renderer classes. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:682</div></div>
<div class="ttc" id="classtgui_1_1ChatBox_html"><div class="ttname"><a href="classtgui_1_1ChatBox.html">tgui::ChatBox</a></div><div class="ttdef"><b>Definition:</b> ChatBox.hpp:45</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Nov 25 2017 17:32:41 for TGUI by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.11
</small></address>
<!-- BEGIN CUSTOM 3 -->
<!-- {% endraw %} -{{""}}-{{""}}>
</div>
{% include page_footer.ext %}
</div>
{% include footer.ext %}
<{{""}}!{{""}}-{{""}}- -->
<!-- END CUSTOM 3 -->
</body>
</html>
